<script lang="ts">
import Component from 'vue-class-component';
import { Prop, Watch } from 'vue-property-decorator';
import type {
  Pixel, Point, Rect,
} from '@/data';
import type { ScrollTo } from '@/logic/ScrollActions';
import LabelBehavior from '../LabelBehavior.vue';
import type { Emitter, Registerer } from '../../canvas/canvas-events';

const DEFAULT_EDGE_DRAG_MARGIN = 100;
const DEFAULT_EDGE_SCROLL_SPEED = 100;

/**
 * The type of the checkEdgeDrag public event handler
 *
 * Allows any component to ask for a resize
 */
type CheckEdgeDrag = (
  dragPosition: Pixel
) => void;

/**
 * Extension of the Registerer type
 *
 * Allows BResizeOnArrowDrag to subscribe to the public event 'check-edge-drag'
 */
type BEdgeDragRegisterer = Registerer & {
  (name: 'check-edge-drag', handler: CheckEdgeDrag): void
};

/**
 * Emitter type, to wrap LabelCanvas.$emit
 *
 * Allows any component to emit 'check-edge-drag' events
 */
export type BEdgeDragEmitter = Emitter & {
  (name: 'check-edge-drag', ...payload: Parameters<CheckEdgeDrag>): void
};

/**
 * Scrolls the canvas to a given onset on canvas creation
 * Currently movements becomes jagged when dragging, because no mouse move is emitted during scroll
 * This could be avoided with a parent to all dragger components
 */
@Component
export default class BScrollOnEdgeDrag extends LabelBehavior<Emitter, BEdgeDragRegisterer> {
  mounted() {
    // Whenever a component requests an edge drag, set the flag
    // TODO: check that mouse if down before setting to true
    this.register('check-edge-drag', () => { this.isEdgeDragging = true; });
    // On mouseup, stop any edge dragging
    this.register('document-mouseup', () => { this.isEdgeDragging = false; });
    // On mousemove, update the current relative mouse position
    this.register('document-mousemove', (e) => { this.mouseX = e.x; });
  }

  @Watch('isEdgeDragging')
  onEdgeDragChange(isDragging: boolean): void {
    // If dragging and no animation running, start anim
    if (isDragging && !this.anim) this.edgeDrag();

    // If not dragging, but animation is running, stop it
    if (!isDragging && this.anim) {
      cancelAnimationFrame(this.anim);
      this.anim = 0;
    }
  }

  edgeDrag() {
    const minX = this.viewRect.x + this.margin;
    const maxX = this.viewRect.x + this.viewRect.width - this.margin;

    // If mouse on left margin, smoothly scroll left
    if (this.mouseX < minX) {
      this.scrollTo({
        x: (this.viewRect.x - this.speed),
        y: 0,
      } as Point, true);
    }

    // If mouse on right margin, smoothly scroll right
    if (this.mouseX > maxX) {
      this.scrollTo({
        x: (this.viewRect.x + this.speed),
        y: 0,
      } as Point, true);
    }

    // The running anim used to scroll
    this.anim = requestAnimationFrame(this.edgeDrag);
  }

  unmounted() {
    // Cancel any existing animation
    this.onEdgeDragChange(false);
  }

  // The id of the requested animation frame
  anim = 0;

  isEdgeDragging = false;

  mouseX = 0 as Pixel;

  @Prop({ default: DEFAULT_EDGE_DRAG_MARGIN })
  margin!: number;

  @Prop({ default: DEFAULT_EDGE_SCROLL_SPEED })
  speed!: number;

  @Prop({ required: true })
  viewRect!: Rect;

  @Prop({ required: true })
  scrollTo!: ScrollTo;
}
</script>
